/*
--------------------------------------------------------------------------------------------------------------------------------------------------------
-- RapidIO IO Packet Logical Layer Concatenation Module IP Core
--
-- This file is the part of the RapidIO Interconnect v3.0 IP Core Project
--
-- Description
-- This Module developed, 
-- 1. Generates logical layer Packets for various format types
-- 2. Depend on the input Ftype value and SOF, the ftype packets are assigned with the
--    data signals 
-- 
--
-- Author(s):
-- Chidhambaranathan (cnaathan@gmail.com)
--
--------------------------------------------------------------------------------------------------------------------------------------------------------
-- 
-- Copyright (c) 2013, Indian Institute of Technology Madras (IIT Madras)
-- All rights reserved.
--
-- Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
--
-- 1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
-- 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and 
--    the following disclaimer in the documentation and/or other materials provided with the distribution.
-- 3. Neither the name of IIT Madras  nor the names of its contributors may be used to endorse or 
--    promote products derived from this software without specific prior written permission.
--
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
-- INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
-- IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
-- OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
-- OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
-- OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-- 
--------------------------------------------------------------------------------------------------------------------------------------------------------
*/


//
// Generated by Bluespec Compiler, version 2013.05.beta2 (build 31258, 2013-05-21)
//
// On Mon Apr 21 12:27:02 IST 2014
//
// Method conflict info:
// Method: _inputs_InitReqIfcPkt
// Conflict-free: _inputs_TargetRespIfcPkt,
// 	       _inputs_MaintenanceIfcPkt,
// 	       _inputs_RxReady_From_IOGeneration,
// 	       outputs_Ftype9_DataStreamingPacket_,
// 	       outputs_TgtRespIfcPkt_,
// 	       outputs_MaintainRespIfcPkt_,
// 	       outputs_InitReqDataCount_,
// 	       outputs_RxRdy_From_Concat_
// Sequenced before (restricted): outputs_Ftype2_IOReqClassPacket_,
// 			       outputs_Ftype5_IOWrClassPacket_,
// 			       outputs_Ftype6_IOStreamWrClassPacket_,
// 			       outputs_Ftype10_MgDOORBELLClass_,
// 			       outputs_Ftype11_MESSAGEClass_,
// 			       outputs_Ftype13_IORespPacket_,
// 			       outputs_Ftype8_IOMaintenancePacket_,
// 			       outputs_InitReqIfcPkt_
// Conflicts: _inputs_InitReqIfcPkt
//
// Method: _inputs_TargetRespIfcPkt
// Conflict-free: _inputs_InitReqIfcPkt,
// 	       _inputs_MaintenanceIfcPkt,
// 	       _inputs_RxReady_From_IOGeneration,
// 	       outputs_Ftype9_DataStreamingPacket_,
// 	       outputs_InitReqIfcPkt_,
// 	       outputs_MaintainRespIfcPkt_,
// 	       outputs_InitReqDataCount_,
// 	       outputs_RxRdy_From_Concat_
// Sequenced before (restricted): outputs_Ftype2_IOReqClassPacket_,
// 			       outputs_Ftype5_IOWrClassPacket_,
// 			       outputs_Ftype6_IOStreamWrClassPacket_,
// 			       outputs_Ftype10_MgDOORBELLClass_,
// 			       outputs_Ftype11_MESSAGEClass_,
// 			       outputs_Ftype13_IORespPacket_,
// 			       outputs_Ftype8_IOMaintenancePacket_,
// 			       outputs_TgtRespIfcPkt_
// Conflicts: _inputs_TargetRespIfcPkt
//
// Method: _inputs_MaintenanceIfcPkt
// Conflict-free: _inputs_InitReqIfcPkt,
// 	       _inputs_TargetRespIfcPkt,
// 	       _inputs_RxReady_From_IOGeneration,
// 	       outputs_Ftype9_DataStreamingPacket_,
// 	       outputs_InitReqIfcPkt_,
// 	       outputs_TgtRespIfcPkt_,
// 	       outputs_InitReqDataCount_,
// 	       outputs_RxRdy_From_Concat_
// Sequenced before (restricted): outputs_Ftype2_IOReqClassPacket_,
// 			       outputs_Ftype5_IOWrClassPacket_,
// 			       outputs_Ftype6_IOStreamWrClassPacket_,
// 			       outputs_Ftype10_MgDOORBELLClass_,
// 			       outputs_Ftype11_MESSAGEClass_,
// 			       outputs_Ftype13_IORespPacket_,
// 			       outputs_Ftype8_IOMaintenancePacket_,
// 			       outputs_MaintainRespIfcPkt_
// Conflicts: _inputs_MaintenanceIfcPkt
//
// Method: _inputs_RxReady_From_IOGeneration
// Conflict-free: _inputs_InitReqIfcPkt,
// 	       _inputs_TargetRespIfcPkt,
// 	       _inputs_MaintenanceIfcPkt,
// 	       outputs_Ftype2_IOReqClassPacket_,
// 	       outputs_Ftype5_IOWrClassPacket_,
// 	       outputs_Ftype6_IOStreamWrClassPacket_,
// 	       outputs_Ftype10_MgDOORBELLClass_,
// 	       outputs_Ftype11_MESSAGEClass_,
// 	       outputs_Ftype13_IORespPacket_,
// 	       outputs_Ftype8_IOMaintenancePacket_,
// 	       outputs_Ftype9_DataStreamingPacket_,
// 	       outputs_InitReqIfcPkt_,
// 	       outputs_TgtRespIfcPkt_,
// 	       outputs_MaintainRespIfcPkt_,
// 	       outputs_InitReqDataCount_
// Sequenced before (restricted): outputs_RxRdy_From_Concat_
// Conflicts: _inputs_RxReady_From_IOGeneration
//
// Method: outputs_Ftype2_IOReqClassPacket_
// Conflict-free: _inputs_RxReady_From_IOGeneration,
// 	       outputs_Ftype2_IOReqClassPacket_,
// 	       outputs_Ftype5_IOWrClassPacket_,
// 	       outputs_Ftype6_IOStreamWrClassPacket_,
// 	       outputs_Ftype10_MgDOORBELLClass_,
// 	       outputs_Ftype11_MESSAGEClass_,
// 	       outputs_Ftype13_IORespPacket_,
// 	       outputs_Ftype8_IOMaintenancePacket_,
// 	       outputs_Ftype9_DataStreamingPacket_,
// 	       outputs_InitReqIfcPkt_,
// 	       outputs_TgtRespIfcPkt_,
// 	       outputs_MaintainRespIfcPkt_,
// 	       outputs_InitReqDataCount_,
// 	       outputs_RxRdy_From_Concat_
// Sequenced after (restricted): _inputs_InitReqIfcPkt,
// 			      _inputs_TargetRespIfcPkt,
// 			      _inputs_MaintenanceIfcPkt
//
// Method: outputs_Ftype5_IOWrClassPacket_
// Conflict-free: _inputs_RxReady_From_IOGeneration,
// 	       outputs_Ftype2_IOReqClassPacket_,
// 	       outputs_Ftype5_IOWrClassPacket_,
// 	       outputs_Ftype6_IOStreamWrClassPacket_,
// 	       outputs_Ftype10_MgDOORBELLClass_,
// 	       outputs_Ftype11_MESSAGEClass_,
// 	       outputs_Ftype13_IORespPacket_,
// 	       outputs_Ftype8_IOMaintenancePacket_,
// 	       outputs_Ftype9_DataStreamingPacket_,
// 	       outputs_InitReqIfcPkt_,
// 	       outputs_TgtRespIfcPkt_,
// 	       outputs_MaintainRespIfcPkt_,
// 	       outputs_InitReqDataCount_,
// 	       outputs_RxRdy_From_Concat_
// Sequenced after (restricted): _inputs_InitReqIfcPkt,
// 			      _inputs_TargetRespIfcPkt,
// 			      _inputs_MaintenanceIfcPkt
//
// Method: outputs_Ftype6_IOStreamWrClassPacket_
// Conflict-free: _inputs_RxReady_From_IOGeneration,
// 	       outputs_Ftype2_IOReqClassPacket_,
// 	       outputs_Ftype5_IOWrClassPacket_,
// 	       outputs_Ftype6_IOStreamWrClassPacket_,
// 	       outputs_Ftype10_MgDOORBELLClass_,
// 	       outputs_Ftype11_MESSAGEClass_,
// 	       outputs_Ftype13_IORespPacket_,
// 	       outputs_Ftype8_IOMaintenancePacket_,
// 	       outputs_Ftype9_DataStreamingPacket_,
// 	       outputs_InitReqIfcPkt_,
// 	       outputs_TgtRespIfcPkt_,
// 	       outputs_MaintainRespIfcPkt_,
// 	       outputs_InitReqDataCount_,
// 	       outputs_RxRdy_From_Concat_
// Sequenced after (restricted): _inputs_InitReqIfcPkt,
// 			      _inputs_TargetRespIfcPkt,
// 			      _inputs_MaintenanceIfcPkt
//
// Method: outputs_Ftype10_MgDOORBELLClass_
// Conflict-free: _inputs_RxReady_From_IOGeneration,
// 	       outputs_Ftype2_IOReqClassPacket_,
// 	       outputs_Ftype5_IOWrClassPacket_,
// 	       outputs_Ftype6_IOStreamWrClassPacket_,
// 	       outputs_Ftype10_MgDOORBELLClass_,
// 	       outputs_Ftype11_MESSAGEClass_,
// 	       outputs_Ftype13_IORespPacket_,
// 	       outputs_Ftype8_IOMaintenancePacket_,
// 	       outputs_Ftype9_DataStreamingPacket_,
// 	       outputs_InitReqIfcPkt_,
// 	       outputs_TgtRespIfcPkt_,
// 	       outputs_MaintainRespIfcPkt_,
// 	       outputs_InitReqDataCount_,
// 	       outputs_RxRdy_From_Concat_
// Sequenced after (restricted): _inputs_InitReqIfcPkt,
// 			      _inputs_TargetRespIfcPkt,
// 			      _inputs_MaintenanceIfcPkt
//
// Method: outputs_Ftype11_MESSAGEClass_
// Conflict-free: _inputs_RxReady_From_IOGeneration,
// 	       outputs_Ftype2_IOReqClassPacket_,
// 	       outputs_Ftype5_IOWrClassPacket_,
// 	       outputs_Ftype6_IOStreamWrClassPacket_,
// 	       outputs_Ftype10_MgDOORBELLClass_,
// 	       outputs_Ftype11_MESSAGEClass_,
// 	       outputs_Ftype13_IORespPacket_,
// 	       outputs_Ftype8_IOMaintenancePacket_,
// 	       outputs_Ftype9_DataStreamingPacket_,
// 	       outputs_InitReqIfcPkt_,
// 	       outputs_TgtRespIfcPkt_,
// 	       outputs_MaintainRespIfcPkt_,
// 	       outputs_InitReqDataCount_,
// 	       outputs_RxRdy_From_Concat_
// Sequenced after (restricted): _inputs_InitReqIfcPkt,
// 			      _inputs_TargetRespIfcPkt,
// 			      _inputs_MaintenanceIfcPkt
//
// Method: outputs_Ftype13_IORespPacket_
// Conflict-free: _inputs_RxReady_From_IOGeneration,
// 	       outputs_Ftype2_IOReqClassPacket_,
// 	       outputs_Ftype5_IOWrClassPacket_,
// 	       outputs_Ftype6_IOStreamWrClassPacket_,
// 	       outputs_Ftype10_MgDOORBELLClass_,
// 	       outputs_Ftype11_MESSAGEClass_,
// 	       outputs_Ftype13_IORespPacket_,
// 	       outputs_Ftype8_IOMaintenancePacket_,
// 	       outputs_Ftype9_DataStreamingPacket_,
// 	       outputs_InitReqIfcPkt_,
// 	       outputs_TgtRespIfcPkt_,
// 	       outputs_MaintainRespIfcPkt_,
// 	       outputs_InitReqDataCount_,
// 	       outputs_RxRdy_From_Concat_
// Sequenced after (restricted): _inputs_InitReqIfcPkt,
// 			      _inputs_TargetRespIfcPkt,
// 			      _inputs_MaintenanceIfcPkt
//
// Method: outputs_Ftype8_IOMaintenancePacket_
// Conflict-free: _inputs_RxReady_From_IOGeneration,
// 	       outputs_Ftype2_IOReqClassPacket_,
// 	       outputs_Ftype5_IOWrClassPacket_,
// 	       outputs_Ftype6_IOStreamWrClassPacket_,
// 	       outputs_Ftype10_MgDOORBELLClass_,
// 	       outputs_Ftype11_MESSAGEClass_,
// 	       outputs_Ftype13_IORespPacket_,
// 	       outputs_Ftype8_IOMaintenancePacket_,
// 	       outputs_Ftype9_DataStreamingPacket_,
// 	       outputs_InitReqIfcPkt_,
// 	       outputs_TgtRespIfcPkt_,
// 	       outputs_MaintainRespIfcPkt_,
// 	       outputs_InitReqDataCount_,
// 	       outputs_RxRdy_From_Concat_
// Sequenced after (restricted): _inputs_InitReqIfcPkt,
// 			      _inputs_TargetRespIfcPkt,
// 			      _inputs_MaintenanceIfcPkt
//
// Method: outputs_Ftype9_DataStreamingPacket_
// Conflict-free: _inputs_InitReqIfcPkt,
// 	       _inputs_TargetRespIfcPkt,
// 	       _inputs_MaintenanceIfcPkt,
// 	       _inputs_RxReady_From_IOGeneration,
// 	       outputs_Ftype2_IOReqClassPacket_,
// 	       outputs_Ftype5_IOWrClassPacket_,
// 	       outputs_Ftype6_IOStreamWrClassPacket_,
// 	       outputs_Ftype10_MgDOORBELLClass_,
// 	       outputs_Ftype11_MESSAGEClass_,
// 	       outputs_Ftype13_IORespPacket_,
// 	       outputs_Ftype8_IOMaintenancePacket_,
// 	       outputs_Ftype9_DataStreamingPacket_,
// 	       outputs_InitReqIfcPkt_,
// 	       outputs_TgtRespIfcPkt_,
// 	       outputs_MaintainRespIfcPkt_,
// 	       outputs_InitReqDataCount_,
// 	       outputs_RxRdy_From_Concat_
//
// Method: outputs_InitReqIfcPkt_
// Conflict-free: _inputs_TargetRespIfcPkt,
// 	       _inputs_MaintenanceIfcPkt,
// 	       _inputs_RxReady_From_IOGeneration,
// 	       outputs_Ftype2_IOReqClassPacket_,
// 	       outputs_Ftype5_IOWrClassPacket_,
// 	       outputs_Ftype6_IOStreamWrClassPacket_,
// 	       outputs_Ftype10_MgDOORBELLClass_,
// 	       outputs_Ftype11_MESSAGEClass_,
// 	       outputs_Ftype13_IORespPacket_,
// 	       outputs_Ftype8_IOMaintenancePacket_,
// 	       outputs_Ftype9_DataStreamingPacket_,
// 	       outputs_InitReqIfcPkt_,
// 	       outputs_TgtRespIfcPkt_,
// 	       outputs_MaintainRespIfcPkt_,
// 	       outputs_InitReqDataCount_,
// 	       outputs_RxRdy_From_Concat_
// Sequenced after (restricted): _inputs_InitReqIfcPkt
//
// Method: outputs_TgtRespIfcPkt_
// Conflict-free: _inputs_InitReqIfcPkt,
// 	       _inputs_MaintenanceIfcPkt,
// 	       _inputs_RxReady_From_IOGeneration,
// 	       outputs_Ftype2_IOReqClassPacket_,
// 	       outputs_Ftype5_IOWrClassPacket_,
// 	       outputs_Ftype6_IOStreamWrClassPacket_,
// 	       outputs_Ftype10_MgDOORBELLClass_,
// 	       outputs_Ftype11_MESSAGEClass_,
// 	       outputs_Ftype13_IORespPacket_,
// 	       outputs_Ftype8_IOMaintenancePacket_,
// 	       outputs_Ftype9_DataStreamingPacket_,
// 	       outputs_InitReqIfcPkt_,
// 	       outputs_TgtRespIfcPkt_,
// 	       outputs_MaintainRespIfcPkt_,
// 	       outputs_InitReqDataCount_,
// 	       outputs_RxRdy_From_Concat_
// Sequenced after (restricted): _inputs_TargetRespIfcPkt
//
// Method: outputs_MaintainRespIfcPkt_
// Conflict-free: _inputs_InitReqIfcPkt,
// 	       _inputs_TargetRespIfcPkt,
// 	       _inputs_RxReady_From_IOGeneration,
// 	       outputs_Ftype2_IOReqClassPacket_,
// 	       outputs_Ftype5_IOWrClassPacket_,
// 	       outputs_Ftype6_IOStreamWrClassPacket_,
// 	       outputs_Ftype10_MgDOORBELLClass_,
// 	       outputs_Ftype11_MESSAGEClass_,
// 	       outputs_Ftype13_IORespPacket_,
// 	       outputs_Ftype8_IOMaintenancePacket_,
// 	       outputs_Ftype9_DataStreamingPacket_,
// 	       outputs_InitReqIfcPkt_,
// 	       outputs_TgtRespIfcPkt_,
// 	       outputs_MaintainRespIfcPkt_,
// 	       outputs_InitReqDataCount_,
// 	       outputs_RxRdy_From_Concat_
// Sequenced after (restricted): _inputs_MaintenanceIfcPkt
//
// Method: outputs_InitReqDataCount_
// Conflict-free: _inputs_InitReqIfcPkt,
// 	       _inputs_TargetRespIfcPkt,
// 	       _inputs_MaintenanceIfcPkt,
// 	       _inputs_RxReady_From_IOGeneration,
// 	       outputs_Ftype2_IOReqClassPacket_,
// 	       outputs_Ftype5_IOWrClassPacket_,
// 	       outputs_Ftype6_IOStreamWrClassPacket_,
// 	       outputs_Ftype10_MgDOORBELLClass_,
// 	       outputs_Ftype11_MESSAGEClass_,
// 	       outputs_Ftype13_IORespPacket_,
// 	       outputs_Ftype8_IOMaintenancePacket_,
// 	       outputs_Ftype9_DataStreamingPacket_,
// 	       outputs_InitReqIfcPkt_,
// 	       outputs_TgtRespIfcPkt_,
// 	       outputs_MaintainRespIfcPkt_,
// 	       outputs_InitReqDataCount_,
// 	       outputs_RxRdy_From_Concat_
//
// Method: outputs_RxRdy_From_Concat_
// Conflict-free: _inputs_InitReqIfcPkt,
// 	       _inputs_TargetRespIfcPkt,
// 	       _inputs_MaintenanceIfcPkt,
// 	       outputs_Ftype2_IOReqClassPacket_,
// 	       outputs_Ftype5_IOWrClassPacket_,
// 	       outputs_Ftype6_IOStreamWrClassPacket_,
// 	       outputs_Ftype10_MgDOORBELLClass_,
// 	       outputs_Ftype11_MESSAGEClass_,
// 	       outputs_Ftype13_IORespPacket_,
// 	       outputs_Ftype8_IOMaintenancePacket_,
// 	       outputs_Ftype9_DataStreamingPacket_,
// 	       outputs_InitReqIfcPkt_,
// 	       outputs_TgtRespIfcPkt_,
// 	       outputs_MaintainRespIfcPkt_,
// 	       outputs_InitReqDataCount_,
// 	       outputs_RxRdy_From_Concat_
// Sequenced after (restricted): _inputs_RxReady_From_IOGeneration
//
//
// Ports:
// Name                         I/O  size props
// outputs_Ftype2_IOReqClassPacket_  O    70
// outputs_Ftype5_IOWrClassPacket_  O   135
// outputs_Ftype6_IOStreamWrClassPacket_  O    53
// outputs_Ftype10_MgDOORBELLClass_  O    30
// outputs_Ftype11_MESSAGEClass_  O    30
// outputs_Ftype13_IORespPacket_  O    87
// outputs_Ftype8_IOMaintenancePacket_  O   109
// outputs_Ftype9_DataStreamingPacket_  O   100 const
// outputs_InitReqIfcPkt_         O   229
// outputs_TgtRespIfcPkt_         O   134
// outputs_MaintainRespIfcPkt_    O   133
// outputs_InitReqDataCount_      O     5 reg
// outputs_RxRdy_From_Concat_     O     1
// CLK                            I     1 clock
// RST_N                          I     1 reset
// _inputs_InitReqIfcPkt_pkt      I   229
// _inputs_TargetRespIfcPkt_pkt   I   134
// _inputs_MaintenanceIfcPkt_pkt  I   133
// _inputs_RxReady_From_IOGeneration_value  I     1
//
// Combinational paths from inputs to outputs:
//   _inputs_InitReqIfcPkt_pkt -> outputs_Ftype2_IOReqClassPacket_
//   _inputs_InitReqIfcPkt_pkt -> outputs_Ftype5_IOWrClassPacket_
//   _inputs_InitReqIfcPkt_pkt -> outputs_Ftype6_IOStreamWrClassPacket_
//   _inputs_InitReqIfcPkt_pkt -> outputs_Ftype10_MgDOORBELLClass_
//   _inputs_InitReqIfcPkt_pkt -> outputs_Ftype11_MESSAGEClass_
//   (_inputs_InitReqIfcPkt_pkt,
//    _inputs_MaintenanceIfcPkt_pkt) -> outputs_Ftype8_IOMaintenancePacket_
//   _inputs_InitReqIfcPkt_pkt -> outputs_InitReqIfcPkt_
//   _inputs_TargetRespIfcPkt_pkt -> outputs_Ftype13_IORespPacket_
//   _inputs_TargetRespIfcPkt_pkt -> outputs_TgtRespIfcPkt_
//   _inputs_MaintenanceIfcPkt_pkt -> outputs_MaintainRespIfcPkt_
//   _inputs_RxReady_From_IOGeneration_value -> outputs_RxRdy_From_Concat_
//
//

`ifdef BSV_ASSIGNMENT_DELAY
`else
  `define BSV_ASSIGNMENT_DELAY
`endif

`ifdef BSV_POSITIVE_RESET
  `define BSV_RESET_VALUE 1'b1
  `define BSV_RESET_EDGE posedge
`else
  `define BSV_RESET_VALUE 1'b0
  `define BSV_RESET_EDGE negedge
`endif

module mkRapidIO_IOPktConcatenation(CLK,
				    RST_N,

				    _inputs_InitReqIfcPkt_pkt,

				    _inputs_TargetRespIfcPkt_pkt,

				    _inputs_MaintenanceIfcPkt_pkt,

				    _inputs_RxReady_From_IOGeneration_value,

				    outputs_Ftype2_IOReqClassPacket_,

				    outputs_Ftype5_IOWrClassPacket_,

				    outputs_Ftype6_IOStreamWrClassPacket_,

				    outputs_Ftype10_MgDOORBELLClass_,

				    outputs_Ftype11_MESSAGEClass_,

				    outputs_Ftype13_IORespPacket_,

				    outputs_Ftype8_IOMaintenancePacket_,

				    outputs_Ftype9_DataStreamingPacket_,

				    outputs_InitReqIfcPkt_,

				    outputs_TgtRespIfcPkt_,

				    outputs_MaintainRespIfcPkt_,

				    outputs_InitReqDataCount_,

				    outputs_RxRdy_From_Concat_);
  input  CLK;
  input  RST_N;

  // action method _inputs_InitReqIfcPkt
  input  [228 : 0] _inputs_InitReqIfcPkt_pkt;

  // action method _inputs_TargetRespIfcPkt
  input  [133 : 0] _inputs_TargetRespIfcPkt_pkt;

  // action method _inputs_MaintenanceIfcPkt
  input  [132 : 0] _inputs_MaintenanceIfcPkt_pkt;

  // action method _inputs_RxReady_From_IOGeneration
  input  _inputs_RxReady_From_IOGeneration_value;

  // value method outputs_Ftype2_IOReqClassPacket_
  output [69 : 0] outputs_Ftype2_IOReqClassPacket_;

  // value method outputs_Ftype5_IOWrClassPacket_
  output [134 : 0] outputs_Ftype5_IOWrClassPacket_;

  // value method outputs_Ftype6_IOStreamWrClassPacket_
  output [52 : 0] outputs_Ftype6_IOStreamWrClassPacket_;

  // value method outputs_Ftype10_MgDOORBELLClass_
  output [29 : 0] outputs_Ftype10_MgDOORBELLClass_;

  // value method outputs_Ftype11_MESSAGEClass_
  output [29 : 0] outputs_Ftype11_MESSAGEClass_;

  // value method outputs_Ftype13_IORespPacket_
  output [86 : 0] outputs_Ftype13_IORespPacket_;

  // value method outputs_Ftype8_IOMaintenancePacket_
  output [108 : 0] outputs_Ftype8_IOMaintenancePacket_;

  // value method outputs_Ftype9_DataStreamingPacket_
  output [99 : 0] outputs_Ftype9_DataStreamingPacket_;

  // value method outputs_InitReqIfcPkt_
  output [228 : 0] outputs_InitReqIfcPkt_;

  // value method outputs_TgtRespIfcPkt_
  output [133 : 0] outputs_TgtRespIfcPkt_;

  // value method outputs_MaintainRespIfcPkt_
  output [132 : 0] outputs_MaintainRespIfcPkt_;

  // value method outputs_InitReqDataCount_
  output [4 : 0] outputs_InitReqDataCount_;

  // value method outputs_RxRdy_From_Concat_
  output outputs_RxRdy_From_Concat_;

  // signals for module outputs
  wire [228 : 0] outputs_InitReqIfcPkt_;
  wire [134 : 0] outputs_Ftype5_IOWrClassPacket_;
  wire [133 : 0] outputs_TgtRespIfcPkt_;
  wire [132 : 0] outputs_MaintainRespIfcPkt_;
  wire [108 : 0] outputs_Ftype8_IOMaintenancePacket_;
  wire [99 : 0] outputs_Ftype9_DataStreamingPacket_;
  wire [86 : 0] outputs_Ftype13_IORespPacket_;
  wire [69 : 0] outputs_Ftype2_IOReqClassPacket_;
  wire [52 : 0] outputs_Ftype6_IOStreamWrClassPacket_;
  wire [29 : 0] outputs_Ftype10_MgDOORBELLClass_,
		outputs_Ftype11_MESSAGEClass_;
  wire [4 : 0] outputs_InitReqDataCount_;
  wire outputs_RxRdy_From_Concat_;

  // inlined wires
  wire [134 : 0] wr_Ftype5_WritePkt$wget;
  wire [108 : 0] wr_Ftype8_MaintenanceResp$wget;
  wire [86 : 0] wr_Ftype13_Response$wget;
  wire [69 : 0] wr_Ftype2_RequestPkt$wget;
  wire [52 : 0] wr_Ftype6_StreamWrPkt$wget;
  wire [29 : 0] wr_Ftype10_DOORBELLPkt$wget, wr_Ftype11_MESSAGEPkt$wget;
  wire wr_Ftype10_DOORBELLPkt$whas,
       wr_Ftype11_MESSAGEPkt$whas,
       wr_Ftype8_MaintenanceResp$whas,
       wr_Read$whas;

  // register rg_DataCount
  reg [3 : 0] rg_DataCount;
  wire [3 : 0] rg_DataCount$D_IN;
  wire rg_DataCount$EN;

  // register rg_LastData
  reg rg_LastData;
  wire rg_LastData$D_IN, rg_LastData$EN;

  // ports of submodule mod_ConvertByteCountToSizeWdPtr
  wire [8 : 0] mod_ConvertByteCountToSizeWdPtr$_inputs_ByteCount_value;
  wire [7 : 0] mod_ConvertByteCountToSizeWdPtr$_inputs_ByteEn_value;
  wire [3 : 0] mod_ConvertByteCountToSizeWdPtr$outputs_Size_;
  wire mod_ConvertByteCountToSizeWdPtr$EN__inputs_ByteCount,
       mod_ConvertByteCountToSizeWdPtr$EN__inputs_ByteEn,
       mod_ConvertByteCountToSizeWdPtr$EN__inputs_Read,
       mod_ConvertByteCountToSizeWdPtr$_inputs_Read_value,
       mod_ConvertByteCountToSizeWdPtr$outputs_WdPointer_;

  // rule scheduling signals
  wire CAN_FIRE_RL_rl_CheckWhetherRdorWr,
       CAN_FIRE_RL_rl_DataValidCount,
       CAN_FIRE_RL_rl_Ftype10DOORBELLClass,
       CAN_FIRE_RL_rl_Ftype11MESSAGEClass,
       CAN_FIRE_RL_rl_Ftype13ResponseClass,
       CAN_FIRE_RL_rl_Ftype2RequestClass,
       CAN_FIRE_RL_rl_Ftype5WriteClass,
       CAN_FIRE_RL_rl_Ftype6StreamWriteClass,
       CAN_FIRE_RL_rl_Ftype8MaintenanceRespClass,
       CAN_FIRE_RL_rl_IfctoGenerateSizeWdPtr,
       CAN_FIRE_RL_rl_ImportInputInterface,
       CAN_FIRE__inputs_InitReqIfcPkt,
       CAN_FIRE__inputs_MaintenanceIfcPkt,
       CAN_FIRE__inputs_RxReady_From_IOGeneration,
       CAN_FIRE__inputs_TargetRespIfcPkt,
       WILL_FIRE_RL_rl_CheckWhetherRdorWr,
       WILL_FIRE_RL_rl_DataValidCount,
       WILL_FIRE_RL_rl_Ftype10DOORBELLClass,
       WILL_FIRE_RL_rl_Ftype11MESSAGEClass,
       WILL_FIRE_RL_rl_Ftype13ResponseClass,
       WILL_FIRE_RL_rl_Ftype2RequestClass,
       WILL_FIRE_RL_rl_Ftype5WriteClass,
       WILL_FIRE_RL_rl_Ftype6StreamWriteClass,
       WILL_FIRE_RL_rl_Ftype8MaintenanceRespClass,
       WILL_FIRE_RL_rl_IfctoGenerateSizeWdPtr,
       WILL_FIRE_RL_rl_ImportInputInterface,
       WILL_FIRE__inputs_InitReqIfcPkt,
       WILL_FIRE__inputs_MaintenanceIfcPkt,
       WILL_FIRE__inputs_RxReady_From_IOGeneration,
       WILL_FIRE__inputs_TargetRespIfcPkt;

  // remaining internal signals
  reg [63 : 0] CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4;
  wire [108 : 0] IF_wr_IreqSOF_whas__4_AND_wr_IreqSOF_wget__5_6_ETC___d213;
  wire [63 : 0] inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3;
  wire [49 : 0] inputs_InitReqIfcPkt_pkt_BITS_119_TO_70__q2;
  wire [20 : 0] x__read_config_offset__h5744;
  wire [7 : 0] new_value_tgtTID__h4315, x__read_tranID__h5743;
  wire [5 : 0] inputs_InitReqIfcPkt_pkt_BITS_7_TO_2__q1;
  wire [3 : 0] x__h4186, x__h4542, x__h5751, x__h5754, x__h5757;
  wire [1 : 0] x__read_tt__h5739;
  wire x__read_wdptr__h5745;

  // action method _inputs_InitReqIfcPkt
  assign CAN_FIRE__inputs_InitReqIfcPkt = 1'd1 ;
  assign WILL_FIRE__inputs_InitReqIfcPkt = 1'd1 ;

  // action method _inputs_TargetRespIfcPkt
  assign CAN_FIRE__inputs_TargetRespIfcPkt = 1'd1 ;
  assign WILL_FIRE__inputs_TargetRespIfcPkt = 1'd1 ;

  // action method _inputs_MaintenanceIfcPkt
  assign CAN_FIRE__inputs_MaintenanceIfcPkt = 1'd1 ;
  assign WILL_FIRE__inputs_MaintenanceIfcPkt = 1'd1 ;

  // action method _inputs_RxReady_From_IOGeneration
  assign CAN_FIRE__inputs_RxReady_From_IOGeneration = 1'd1 ;
  assign WILL_FIRE__inputs_RxReady_From_IOGeneration = 1'd1 ;

  // value method outputs_Ftype2_IOReqClassPacket_
  assign outputs_Ftype2_IOReqClassPacket_ = wr_Ftype2_RequestPkt$wget ;

  // value method outputs_Ftype5_IOWrClassPacket_
  assign outputs_Ftype5_IOWrClassPacket_ = wr_Ftype5_WritePkt$wget ;

  // value method outputs_Ftype6_IOStreamWrClassPacket_
  assign outputs_Ftype6_IOStreamWrClassPacket_ = wr_Ftype6_StreamWrPkt$wget ;

  // value method outputs_Ftype10_MgDOORBELLClass_
  assign outputs_Ftype10_MgDOORBELLClass_ =
	     wr_Ftype10_DOORBELLPkt$whas ?
	       wr_Ftype10_DOORBELLPkt$wget :
	       30'd0 ;

  // value method outputs_Ftype11_MESSAGEClass_
  assign outputs_Ftype11_MESSAGEClass_ =
	     wr_Ftype11_MESSAGEPkt$whas ? wr_Ftype11_MESSAGEPkt$wget : 30'd0 ;

  // value method outputs_Ftype13_IORespPacket_
  assign outputs_Ftype13_IORespPacket_ = wr_Ftype13_Response$wget ;

  // value method outputs_Ftype8_IOMaintenancePacket_
  assign outputs_Ftype8_IOMaintenancePacket_ =
	     { x__read_tt__h5739,
	       x__h5751,
	       x__h5754,
	       x__h5757,
	       x__read_tranID__h5743,
	       x__read_config_offset__h5744,
	       x__read_wdptr__h5745,
	       wr_Ftype8_MaintenanceResp$whas &&
	       wr_Ftype8_MaintenanceResp$wget[64],
	       wr_Ftype8_MaintenanceResp$wget[63:0] } ;

  // value method outputs_Ftype9_DataStreamingPacket_
  assign outputs_Ftype9_DataStreamingPacket_ = 100'd0 ;

  // value method outputs_InitReqIfcPkt_
  assign outputs_InitReqIfcPkt_ = _inputs_InitReqIfcPkt_pkt ;

  // value method outputs_TgtRespIfcPkt_
  assign outputs_TgtRespIfcPkt_ = _inputs_TargetRespIfcPkt_pkt ;

  // value method outputs_MaintainRespIfcPkt_
  assign outputs_MaintainRespIfcPkt_ = _inputs_MaintenanceIfcPkt_pkt ;

  // value method outputs_InitReqDataCount_
  assign outputs_InitReqDataCount_ = { rg_LastData, rg_DataCount } ;

  // value method outputs_RxRdy_From_Concat_
  assign outputs_RxRdy_From_Concat_ =
	     _inputs_RxReady_From_IOGeneration_value ;

  // submodule mod_ConvertByteCountToSizeWdPtr
  mkRapidIO_InitEncoder_WdPtr_Size mod_ConvertByteCountToSizeWdPtr(.CLK(CLK),
								   .RST_N(RST_N),
								   ._inputs_ByteCount_value(mod_ConvertByteCountToSizeWdPtr$_inputs_ByteCount_value),
								   ._inputs_ByteEn_value(mod_ConvertByteCountToSizeWdPtr$_inputs_ByteEn_value),
								   ._inputs_Read_value(mod_ConvertByteCountToSizeWdPtr$_inputs_Read_value),
								   .EN__inputs_Read(mod_ConvertByteCountToSizeWdPtr$EN__inputs_Read),
								   .EN__inputs_ByteCount(mod_ConvertByteCountToSizeWdPtr$EN__inputs_ByteCount),
								   .EN__inputs_ByteEn(mod_ConvertByteCountToSizeWdPtr$EN__inputs_ByteEn),
								   .RDY__inputs_Read(),
								   .RDY__inputs_ByteCount(),
								   .RDY__inputs_ByteEn(),
								   .outputs_Size_(mod_ConvertByteCountToSizeWdPtr$outputs_Size_),
								   .RDY_outputs_Size_(),
								   .outputs_WdPointer_(mod_ConvertByteCountToSizeWdPtr$outputs_WdPointer_),
								   .RDY_outputs_WdPointer_());

  // rule RL_rl_ImportInputInterface
  assign CAN_FIRE_RL_rl_ImportInputInterface = 1'd1 ;
  assign WILL_FIRE_RL_rl_ImportInputInterface = 1'd1 ;

  // rule RL_rl_CheckWhetherRdorWr
  assign CAN_FIRE_RL_rl_CheckWhetherRdorWr = 1'd1 ;
  assign WILL_FIRE_RL_rl_CheckWhetherRdorWr = 1'd1 ;

  // rule RL_rl_IfctoGenerateSizeWdPtr
  assign CAN_FIRE_RL_rl_IfctoGenerateSizeWdPtr =
	     _inputs_InitReqIfcPkt_pkt[228] &&
	     _inputs_InitReqIfcPkt_pkt[155:152] != 4'd6 ;
  assign WILL_FIRE_RL_rl_IfctoGenerateSizeWdPtr =
	     CAN_FIRE_RL_rl_IfctoGenerateSizeWdPtr ;

  // rule RL_rl_Ftype2RequestClass
  assign CAN_FIRE_RL_rl_Ftype2RequestClass = 1'd1 ;
  assign WILL_FIRE_RL_rl_Ftype2RequestClass = 1'd1 ;

  // rule RL_rl_Ftype5WriteClass
  assign CAN_FIRE_RL_rl_Ftype5WriteClass = 1'd1 ;
  assign WILL_FIRE_RL_rl_Ftype5WriteClass = 1'd1 ;

  // rule RL_rl_Ftype6StreamWriteClass
  assign CAN_FIRE_RL_rl_Ftype6StreamWriteClass = 1'd1 ;
  assign WILL_FIRE_RL_rl_Ftype6StreamWriteClass = 1'd1 ;

  // rule RL_rl_Ftype8MaintenanceRespClass
  assign CAN_FIRE_RL_rl_Ftype8MaintenanceRespClass = 1'd1 ;
  assign WILL_FIRE_RL_rl_Ftype8MaintenanceRespClass = 1'd1 ;

  // rule RL_rl_Ftype10DOORBELLClass
  assign CAN_FIRE_RL_rl_Ftype10DOORBELLClass = 1'd1 ;
  assign WILL_FIRE_RL_rl_Ftype10DOORBELLClass = 1'd1 ;

  // rule RL_rl_Ftype11MESSAGEClass
  assign CAN_FIRE_RL_rl_Ftype11MESSAGEClass = 1'd1 ;
  assign WILL_FIRE_RL_rl_Ftype11MESSAGEClass = 1'd1 ;

  // rule RL_rl_Ftype13ResponseClass
  assign CAN_FIRE_RL_rl_Ftype13ResponseClass = 1'd1 ;
  assign WILL_FIRE_RL_rl_Ftype13ResponseClass = 1'd1 ;

  // rule RL_rl_DataValidCount
  assign CAN_FIRE_RL_rl_DataValidCount = 1'd1 ;
  assign WILL_FIRE_RL_rl_DataValidCount = 1'd1 ;

  // inlined wires
  assign wr_Read$whas =
	     _inputs_InitReqIfcPkt_pkt[155:152] == 4'd2 ||
	     _inputs_InitReqIfcPkt_pkt[155:152] == 4'd7 ;
  assign wr_Ftype2_RequestPkt$wget =
	     (_inputs_InitReqIfcPkt_pkt[228] &&
	      _inputs_InitReqIfcPkt_pkt[155:152] == 4'd2) ?
	       { _inputs_InitReqIfcPkt_pkt[224:223],
		 _inputs_InitReqIfcPkt_pkt[155:152],
		 _inputs_InitReqIfcPkt_pkt[53:50],
		 mod_ConvertByteCountToSizeWdPtr$outputs_Size_,
		 _inputs_InitReqIfcPkt_pkt[61:54],
		 inputs_InitReqIfcPkt_pkt_BITS_119_TO_70__q2[47:3],
		 mod_ConvertByteCountToSizeWdPtr$outputs_WdPointer_,
		 inputs_InitReqIfcPkt_pkt_BITS_119_TO_70__q2[49:48] } :
	       70'd0 ;
  assign wr_Ftype5_WritePkt$wget =
	     (_inputs_InitReqIfcPkt_pkt[228] &&
	      _inputs_InitReqIfcPkt_pkt[155:152] == 4'd5) ?
	       { _inputs_InitReqIfcPkt_pkt[224:223],
		 _inputs_InitReqIfcPkt_pkt[155:152],
		 _inputs_InitReqIfcPkt_pkt[53:50],
		 mod_ConvertByteCountToSizeWdPtr$outputs_Size_,
		 _inputs_InitReqIfcPkt_pkt[61:54],
		 inputs_InitReqIfcPkt_pkt_BITS_119_TO_70__q2[47:3],
		 mod_ConvertByteCountToSizeWdPtr$outputs_WdPointer_,
		 inputs_InitReqIfcPkt_pkt_BITS_119_TO_70__q2[49:48],
		 1'd1,
		 CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 } :
	       135'h000000000000000000AAAAAAAAAAAAAAAA ;
  assign wr_Ftype6_StreamWrPkt$wget =
	     (_inputs_InitReqIfcPkt_pkt[228] &&
	      _inputs_InitReqIfcPkt_pkt[155:152] == 4'd6) ?
	       { _inputs_InitReqIfcPkt_pkt[224:223],
		 _inputs_InitReqIfcPkt_pkt[155:152],
		 inputs_InitReqIfcPkt_pkt_BITS_119_TO_70__q2[47:3],
		 inputs_InitReqIfcPkt_pkt_BITS_119_TO_70__q2[49:48] } :
	       53'd0 ;
  assign wr_Ftype13_Response$wget =
	     (_inputs_TargetRespIfcPkt_pkt[133] &&
	      _inputs_TargetRespIfcPkt_pkt[60:57] == 4'd13) ?
	       { _inputs_TargetRespIfcPkt_pkt[129:128],
		 _inputs_TargetRespIfcPkt_pkt[60:57],
		 _inputs_TargetRespIfcPkt_pkt[12:9],
		 _inputs_TargetRespIfcPkt_pkt[24:21],
		 new_value_tgtTID__h4315,
		 _inputs_TargetRespIfcPkt_pkt[131],
		 _inputs_TargetRespIfcPkt_pkt[127:64] } :
	       87'h000000AAAAAAAAAAAAAAAA ;
  assign wr_Ftype8_MaintenanceResp$wget =
	     (_inputs_MaintenanceIfcPkt_pkt[132] &&
	      _inputs_MaintenanceIfcPkt_pkt[60:57] == 4'd8) ?
	       { _inputs_MaintenanceIfcPkt_pkt[129:128],
		 _inputs_MaintenanceIfcPkt_pkt[60:53],
		 _inputs_MaintenanceIfcPkt_pkt[3:0],
		 _inputs_MaintenanceIfcPkt_pkt[12:5],
		 (_inputs_MaintenanceIfcPkt_pkt[56:53] == 4'd2) ?
		   { 23'd1, _inputs_MaintenanceIfcPkt_pkt[127:64] } :
		   { 23'd0, _inputs_MaintenanceIfcPkt_pkt[127:64] } } :
	       IF_wr_IreqSOF_whas__4_AND_wr_IreqSOF_wget__5_6_ETC___d213 ;
  assign wr_Ftype8_MaintenanceResp$whas =
	     _inputs_MaintenanceIfcPkt_pkt[132] &&
	     _inputs_MaintenanceIfcPkt_pkt[60:57] == 4'd8 &&
	     (_inputs_MaintenanceIfcPkt_pkt[56:53] == 4'd2 ||
	      _inputs_MaintenanceIfcPkt_pkt[56:53] == 4'd3) ||
	     (!_inputs_MaintenanceIfcPkt_pkt[132] ||
	      _inputs_MaintenanceIfcPkt_pkt[60:57] != 4'd8) &&
	     (_inputs_InitReqIfcPkt_pkt[53:50] == 4'd0 ||
	      _inputs_InitReqIfcPkt_pkt[53:50] == 4'd1 ||
	      !_inputs_InitReqIfcPkt_pkt[228] ||
	      _inputs_InitReqIfcPkt_pkt[155:152] != 4'd8) ;
  assign wr_Ftype10_DOORBELLPkt$wget =
	     { _inputs_InitReqIfcPkt_pkt[224:223],
	       _inputs_InitReqIfcPkt_pkt[155:152],
	       _inputs_InitReqIfcPkt_pkt[61:54],
	       _inputs_InitReqIfcPkt_pkt[31:16] } ;
  assign wr_Ftype10_DOORBELLPkt$whas =
	     _inputs_InitReqIfcPkt_pkt[228] &&
	     _inputs_InitReqIfcPkt_pkt[155:152] == 4'd10 ;
  assign wr_Ftype11_MESSAGEPkt$wget =
	     { _inputs_InitReqIfcPkt_pkt[224:223],
	       _inputs_InitReqIfcPkt_pkt[155:152],
	       _inputs_InitReqIfcPkt_pkt[15:12],
	       4'b1010,
	       _inputs_InitReqIfcPkt_pkt[61:54],
	       _inputs_InitReqIfcPkt_pkt[1:0],
	       inputs_InitReqIfcPkt_pkt_BITS_7_TO_2__q1[1:0],
	       x__h4186 } ;
  assign wr_Ftype11_MESSAGEPkt$whas =
	     _inputs_InitReqIfcPkt_pkt[228] &&
	     _inputs_InitReqIfcPkt_pkt[155:152] == 4'd11 ;

  // register rg_DataCount
  assign rg_DataCount$D_IN =
	     _inputs_InitReqIfcPkt_pkt[226] ?
	       (_inputs_InitReqIfcPkt_pkt[228] ? 4'd1 : x__h4542) :
	       4'd0 ;
  assign rg_DataCount$EN = 1'd1 ;

  // register rg_LastData
  assign rg_LastData$D_IN =
	     _inputs_InitReqIfcPkt_pkt[226] &&
	     !_inputs_InitReqIfcPkt_pkt[228] &&
	     _inputs_InitReqIfcPkt_pkt[227] ;
  assign rg_LastData$EN = 1'd1 ;

  // submodule mod_ConvertByteCountToSizeWdPtr
  assign mod_ConvertByteCountToSizeWdPtr$_inputs_ByteCount_value =
	     _inputs_InitReqIfcPkt_pkt[49:41] ;
  assign mod_ConvertByteCountToSizeWdPtr$_inputs_ByteEn_value =
	     _inputs_InitReqIfcPkt_pkt[40:33] ;
  assign mod_ConvertByteCountToSizeWdPtr$_inputs_Read_value =
	     wr_Read$whas && _inputs_InitReqIfcPkt_pkt[155:152] == 4'd2 ;
  assign mod_ConvertByteCountToSizeWdPtr$EN__inputs_Read =
	     CAN_FIRE_RL_rl_IfctoGenerateSizeWdPtr ;
  assign mod_ConvertByteCountToSizeWdPtr$EN__inputs_ByteCount =
	     CAN_FIRE_RL_rl_IfctoGenerateSizeWdPtr ;
  assign mod_ConvertByteCountToSizeWdPtr$EN__inputs_ByteEn =
	     CAN_FIRE_RL_rl_IfctoGenerateSizeWdPtr ;

  // remaining internal signals
  assign IF_wr_IreqSOF_whas__4_AND_wr_IreqSOF_wget__5_6_ETC___d213 =
	     (_inputs_InitReqIfcPkt_pkt[228] &&
	      _inputs_InitReqIfcPkt_pkt[155:152] == 4'd8) ?
	       { _inputs_InitReqIfcPkt_pkt[224:223],
		 _inputs_InitReqIfcPkt_pkt[155:152],
		 _inputs_InitReqIfcPkt_pkt[53:50],
		 mod_ConvertByteCountToSizeWdPtr$outputs_Size_,
		 _inputs_InitReqIfcPkt_pkt[61:54],
		 inputs_InitReqIfcPkt_pkt_BITS_119_TO_70__q2[23:3],
		 mod_ConvertByteCountToSizeWdPtr$outputs_WdPointer_,
		 _inputs_InitReqIfcPkt_pkt[53:50] != 4'd0,
		 _inputs_InitReqIfcPkt_pkt[222:159] } :
	       109'h000000000000AAAAAAAAAAAAAAAA ;
  assign inputs_InitReqIfcPkt_pkt_BITS_119_TO_70__q2 =
	     _inputs_InitReqIfcPkt_pkt[119:70] ;
  assign inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3 =
	     _inputs_InitReqIfcPkt_pkt[222:159] ;
  assign inputs_InitReqIfcPkt_pkt_BITS_7_TO_2__q1 =
	     _inputs_InitReqIfcPkt_pkt[7:2] ;
  assign new_value_tgtTID__h4315 =
	     (_inputs_TargetRespIfcPkt_pkt[12:9] == 4'h1) ?
	       { _inputs_TargetRespIfcPkt_pkt[1:0],
		 _inputs_TargetRespIfcPkt_pkt[3:2],
		 _inputs_TargetRespIfcPkt_pkt[7:4] } :
	       _inputs_TargetRespIfcPkt_pkt[20:13] ;
  assign x__h4186 =
	     (_inputs_InitReqIfcPkt_pkt[15:12] == 4'b0) ?
	       inputs_InitReqIfcPkt_pkt_BITS_7_TO_2__q1[5:2] :
	       _inputs_InitReqIfcPkt_pkt[11:8] ;
  assign x__h4542 = rg_DataCount + 4'd1 ;
  assign x__h5751 =
	     wr_Ftype8_MaintenanceResp$whas ?
	       wr_Ftype8_MaintenanceResp$wget[106:103] :
	       4'd0 ;
  assign x__h5754 =
	     wr_Ftype8_MaintenanceResp$whas ?
	       wr_Ftype8_MaintenanceResp$wget[102:99] :
	       4'd0 ;
  assign x__h5757 =
	     wr_Ftype8_MaintenanceResp$whas ?
	       wr_Ftype8_MaintenanceResp$wget[98:95] :
	       4'd0 ;
  assign x__read_config_offset__h5744 =
	     wr_Ftype8_MaintenanceResp$whas ?
	       wr_Ftype8_MaintenanceResp$wget[86:66] :
	       21'd0 ;
  assign x__read_tranID__h5743 =
	     wr_Ftype8_MaintenanceResp$whas ?
	       wr_Ftype8_MaintenanceResp$wget[94:87] :
	       8'd0 ;
  assign x__read_tt__h5739 =
	     wr_Ftype8_MaintenanceResp$whas ?
	       wr_Ftype8_MaintenanceResp$wget[108:107] :
	       2'd0 ;
  assign x__read_wdptr__h5745 =
	     wr_Ftype8_MaintenanceResp$whas &&
	     wr_Ftype8_MaintenanceResp$wget[65] ;
  always@(_inputs_InitReqIfcPkt_pkt or
	  inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3)
  begin
    case (_inputs_InitReqIfcPkt_pkt[40:33])
      8'h01:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { 56'h0, inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[7:0] };
      8'h02:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { 48'h0,
		inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[15:8],
		8'h0 };
      8'h03:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { 48'h0, inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[15:0] };
      8'h04:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { 40'h0,
		inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[23:16],
		16'h0 };
      8'h07:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { 40'h0, inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[23:0] };
      8'h08:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { 32'h0,
		inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[31:24],
		24'h0 };
      8'h0C:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { 32'h0,
		inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[31:16],
		16'h0 };
      8'h0F:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { 32'h0, inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[31:0] };
      8'h10:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { 24'h0,
		inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[39:32],
		32'h0 };
      8'h1F:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { 24'h0, inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[39:0] };
      8'h20:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { 16'h0,
		inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[47:40],
		40'h0 };
      8'h30:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { 16'h0,
		inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[47:32],
		32'h0 };
      8'h3F:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { 16'h0, inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[47:0] };
      8'h40:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { 8'h0,
		inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[55:48],
		48'h0 };
      8'h7F:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { 8'h0, inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[55:0] };
      8'h80:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[63:56], 56'h0 };
      8'hC0:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[63:48], 48'h0 };
      8'hE0:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[63:40], 40'h0 };
      8'hF0:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[63:32], 32'h0 };
      8'hF8:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[63:24], 24'h0 };
      8'hFC:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[63:16], 16'h0 };
      8'hFE:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      { inputs_InitReqIfcPkt_pkt_BITS_222_TO_159__q3[63:8], 8'h0 };
      8'hFF:
	  CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
	      _inputs_InitReqIfcPkt_pkt[222:159];
      default: CASE_inputs_InitReqIfcPkt_pkt_BITS_40_TO_33_0x_ETC__q4 =
		   _inputs_InitReqIfcPkt_pkt[222:159];
    endcase
  end

  // handling of inlined registers

  always@(posedge CLK)
  begin
    if (RST_N == `BSV_RESET_VALUE)
      begin
        rg_DataCount <= `BSV_ASSIGNMENT_DELAY 4'd0;
	rg_LastData <= `BSV_ASSIGNMENT_DELAY 1'd0;
      end
    else
      begin
        if (rg_DataCount$EN)
	  rg_DataCount <= `BSV_ASSIGNMENT_DELAY rg_DataCount$D_IN;
	if (rg_LastData$EN)
	  rg_LastData <= `BSV_ASSIGNMENT_DELAY rg_LastData$D_IN;
      end
  end

  // synopsys translate_off
  `ifdef BSV_NO_INITIAL_BLOCKS
  `else // not BSV_NO_INITIAL_BLOCKS
  initial
  begin
    rg_DataCount = 4'hA;
    rg_LastData = 1'h0;
  end
  `endif // BSV_NO_INITIAL_BLOCKS
  // synopsys translate_on
endmodule  // mkRapidIO_IOPktConcatenation

